from ...tl.tlobject import TLObject


class ChannelAdminLogEventActionChangeStickerSet(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channelAdminLogEventActionChangeStickerSet#b1c3caa7 prev_stickerset:InputStickerSet new_stickerset:InputStickerSet = ChannelAdminLogEventAction"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xb1c3caa7
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb2b987f3

    def __init__(self, prev_stickerset, new_stickerset):
        """
        :param prev_stickerset: Telegram type: "InputStickerSet".
        :param new_stickerset: Telegram type: "InputStickerSet".

        Constructor for ChannelAdminLogEventAction: Instance of either ChannelAdminLogEventActionChangeTitle, ChannelAdminLogEventActionChangeAbout, ChannelAdminLogEventActionChangeUsername, ChannelAdminLogEventActionChangePhoto, ChannelAdminLogEventActionToggleInvites, ChannelAdminLogEventActionToggleSignatures, ChannelAdminLogEventActionUpdatePinned, ChannelAdminLogEventActionEditMessage, ChannelAdminLogEventActionDeleteMessage, ChannelAdminLogEventActionParticipantJoin, ChannelAdminLogEventActionParticipantLeave, ChannelAdminLogEventActionParticipantInvite, ChannelAdminLogEventActionParticipantToggleBan, ChannelAdminLogEventActionParticipantToggleAdmin, ChannelAdminLogEventActionChangeStickerSet.
        """
        super().__init__()

        self.prev_stickerset = prev_stickerset
        self.new_stickerset = new_stickerset

    def to_dict(self):
        return {
            'prev_stickerset': None if self.prev_stickerset is None else self.prev_stickerset.to_dict(),
            'new_stickerset': None if self.new_stickerset is None else self.new_stickerset.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(ChannelAdminLogEventActionChangeStickerSet.constructor_id, signed=False)
        self.prev_stickerset.on_send(writer)
        self.new_stickerset.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ChannelAdminLogEventActionChangeStickerSet(None, None)

    def on_response(self, reader):
        self.prev_stickerset = reader.tgread_object()
        self.new_stickerset = reader.tgread_object()

    def __repr__(self):
        return 'channelAdminLogEventActionChangeStickerSet#b1c3caa7 prev_stickerset:InputStickerSet new_stickerset:InputStickerSet = ChannelAdminLogEventAction'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
