from ....tl.tlobject import TLObject


class FavedStickers(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messages.favedStickers#f37f2f16 hash:int packs:Vector<StickerPack> stickers:Vector<Document> = messages.FavedStickers"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xf37f2f16
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x8e736fb9

    def __init__(self, hash, packs, stickers):
        """
        :param hash: Telegram type: "int".
        :param packs: Telegram type: "StickerPack". Must be a list.
        :param stickers: Telegram type: "Document". Must be a list.

        Constructor for messages.FavedStickers: Instance of either FavedStickersNotModified, FavedStickers.
        """
        super().__init__()

        self.hash = hash
        self.packs = packs
        self.stickers = stickers

    def to_dict(self):
        return {
            'hash': self.hash,
            'packs': [] if self.packs is None else [None if x is None else x.to_dict() for x in self.packs],
            'stickers': [] if self.stickers is None else [None if x is None else x.to_dict() for x in self.stickers],
        }

    def on_send(self, writer):
        writer.write_int(FavedStickers.constructor_id, signed=False)
        writer.write_int(self.hash)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.packs))
        for _x in self.packs:
            _x.on_send(writer)

        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.stickers))
        for _x in self.stickers:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return FavedStickers(None, None, None)

    def on_response(self, reader):
        self.hash = reader.read_int()
        reader.read_int()  # Vector's constructor ID
        self.packs = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.packs.append(_x)

        reader.read_int()  # Vector's constructor ID
        self.stickers = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.stickers.append(_x)

    def __repr__(self):
        return 'messages.favedStickers#f37f2f16 hash:int packs:Vector<StickerPack> stickers:Vector<Document> = messages.FavedStickers'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
